package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.TSSDPolicy;
import com.sa.ibiz.demo.demo.domain.TSSDTask;

/**
 * 实体[TSSDTaskPolicy] 数据对象
 */
@TableName(value = "T_SRFTSSDTASKPOLICY",resultMap = "TSSDTaskPolicyResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class TSSDTaskPolicy extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private TSSDPolicy tssdpolicy;
    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private TSSDTask tssdtask;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String reserver;
    private String reserver2;
    private String reserver3;
    private String reserver4;
    private String tssdpolicyid;
    @TableField(exist = false)//逻辑属性
    private String tssdpolicyname;
    private String tssdtaskid;
    @TableField(exist = false)//逻辑属性
    private String tssdtaskname;
    @TableId(value= "tssdtaskpolicyid",type=IdType.UUID)//指定主键生成策略
    private String tssdtaskpolicyid;
    private String tssdtaskpolicyname;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[保留字段]
     *  @param reserver
     */
    public void setReserver(String reserver){
        if(StringUtils.isEmpty(reserver))
            reserver=null;
        this.reserver = reserver;
        this.set("reserverdirtyflag",true);
    }
    /**
     *  获取属性值[保留字段]
     */
    public String getReserver(){
        return this.reserver;
    }
    /**
     *  重置属性值[保留字段]
     */
    public void resetReserver(){
        this.set("reserverdirtyflag",false);
        this.reserver = null;
    }
    /**
     *  设置属性值[保留字段2]
     *  @param reserver2
     */
    public void setReserver2(String reserver2){
        if(StringUtils.isEmpty(reserver2))
            reserver2=null;
        this.reserver2 = reserver2;
        this.set("reserver2dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段2]
     */
    public String getReserver2(){
        return this.reserver2;
    }
    /**
     *  重置属性值[保留字段2]
     */
    public void resetReserver2(){
        this.set("reserver2dirtyflag",false);
        this.reserver2 = null;
    }
    /**
     *  设置属性值[保留字段3]
     *  @param reserver3
     */
    public void setReserver3(String reserver3){
        if(StringUtils.isEmpty(reserver3))
            reserver3=null;
        this.reserver3 = reserver3;
        this.set("reserver3dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段3]
     */
    public String getReserver3(){
        return this.reserver3;
    }
    /**
     *  重置属性值[保留字段3]
     */
    public void resetReserver3(){
        this.set("reserver3dirtyflag",false);
        this.reserver3 = null;
    }
    /**
     *  设置属性值[保留字段4]
     *  @param reserver4
     */
    public void setReserver4(String reserver4){
        if(StringUtils.isEmpty(reserver4))
            reserver4=null;
        this.reserver4 = reserver4;
        this.set("reserver4dirtyflag",true);
    }
    /**
     *  获取属性值[保留字段4]
     */
    public String getReserver4(){
        return this.reserver4;
    }
    /**
     *  重置属性值[保留字段4]
     */
    public void resetReserver4(){
        this.set("reserver4dirtyflag",false);
        this.reserver4 = null;
    }
    /**
     *  设置属性值[任务运行策略]
     *  @param tssdpolicyid
     */
    public void setTssdpolicyid(String tssdpolicyid){
        if(StringUtils.isEmpty(tssdpolicyid))
            tssdpolicyid=null;
        this.tssdpolicyid = tssdpolicyid;
        this.set("tssdpolicyiddirtyflag",true);
    }
    /**
     *  获取属性值[任务运行策略]
     */
    public String getTssdpolicyid(){
        return this.tssdpolicyid;
    }
    /**
     *  重置属性值[任务运行策略]
     */
    public void resetTssdpolicyid(){
        this.set("tssdpolicyiddirtyflag",false);
        this.tssdpolicyid = null;
    }
    /**
     *  设置属性值[任务运行策略]
     *  @param tssdpolicyname
     */
    public void setTssdpolicyname(String tssdpolicyname){
        if(StringUtils.isEmpty(tssdpolicyname))
            tssdpolicyname=null;
        this.tssdpolicyname = tssdpolicyname;
        this.set("tssdpolicynamedirtyflag",true);
    }
    /**
     *  获取属性值[任务运行策略]
     */
    public String getTssdpolicyname(){
        return this.tssdpolicyname;
    }
    /**
     *  重置属性值[任务运行策略]
     */
    public void resetTssdpolicyname(){
        this.set("tssdpolicynamedirtyflag",false);
        this.tssdpolicyname = null;
    }
    /**
     *  设置属性值[调度任务]
     *  @param tssdtaskid
     */
    public void setTssdtaskid(String tssdtaskid){
        if(StringUtils.isEmpty(tssdtaskid))
            tssdtaskid=null;
        this.tssdtaskid = tssdtaskid;
        this.set("tssdtaskiddirtyflag",true);
    }
    /**
     *  获取属性值[调度任务]
     */
    public String getTssdtaskid(){
        return this.tssdtaskid;
    }
    /**
     *  重置属性值[调度任务]
     */
    public void resetTssdtaskid(){
        this.set("tssdtaskiddirtyflag",false);
        this.tssdtaskid = null;
    }
    /**
     *  设置属性值[调度任务]
     *  @param tssdtaskname
     */
    public void setTssdtaskname(String tssdtaskname){
        if(StringUtils.isEmpty(tssdtaskname))
            tssdtaskname=null;
        this.tssdtaskname = tssdtaskname;
        this.set("tssdtasknamedirtyflag",true);
    }
    /**
     *  获取属性值[调度任务]
     */
    public String getTssdtaskname(){
        return this.tssdtaskname;
    }
    /**
     *  重置属性值[调度任务]
     */
    public void resetTssdtaskname(){
        this.set("tssdtasknamedirtyflag",false);
        this.tssdtaskname = null;
    }
    /**
     *  设置属性值[调度任务项策略标识]
     *  @param tssdtaskpolicyid
     */
    public void setTssdtaskpolicyid(String tssdtaskpolicyid){
        if(StringUtils.isEmpty(tssdtaskpolicyid))
            tssdtaskpolicyid=null;
        this.tssdtaskpolicyid = tssdtaskpolicyid;
        this.set("tssdtaskpolicyiddirtyflag",true);
    }
    /**
     *  获取属性值[调度任务项策略标识]
     */
    public String getTssdtaskpolicyid(){
        return this.tssdtaskpolicyid;
    }
    /**
     *  重置属性值[调度任务项策略标识]
     */
    public void resetTssdtaskpolicyid(){
        this.set("tssdtaskpolicyiddirtyflag",false);
        this.tssdtaskpolicyid = null;
    }
    /**
     *  设置属性值[调度任务项策略名称]
     *  @param tssdtaskpolicyname
     */
    public void setTssdtaskpolicyname(String tssdtaskpolicyname){
        if(StringUtils.isEmpty(tssdtaskpolicyname))
            tssdtaskpolicyname=null;
        this.tssdtaskpolicyname = tssdtaskpolicyname;
        this.set("tssdtaskpolicynamedirtyflag",true);
    }
    /**
     *  获取属性值[调度任务项策略名称]
     */
    public String getTssdtaskpolicyname(){
        return this.tssdtaskpolicyname;
    }
    /**
     *  重置属性值[调度任务项策略名称]
     */
    public void resetTssdtaskpolicyname(){
        this.set("tssdtaskpolicynamedirtyflag",false);
        this.tssdtaskpolicyname = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
     /**
     *  获取主实体关联数据[TSSDPolicy]
     */
    public TSSDPolicy getTssdpolicy() {
        return tssdpolicy;
    }
    /**
     *  设置主实体关联数据[TSSDPolicy]
     */
    public void setTssdpolicy(TSSDPolicy tssdpolicy) {
        this.tssdpolicy = tssdpolicy;
    }

     /**
     *  获取主实体关联数据[TSSDTask]
     */
    public TSSDTask getTssdtask() {
        return tssdtask;
    }
    /**
     *  设置主实体关联数据[TSSDTask]
     */
    public void setTssdtask(TSSDTask tssdtask) {
        this.tssdtask = tssdtask;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetReserver();
        resetReserver2();
        resetReserver3();
        resetReserver4();
        resetTssdpolicyid();
        resetTssdpolicyname();
        resetTssdtaskid();
        resetTssdtaskname();
        resetTssdtaskpolicyid();
        resetTssdtaskpolicyname();
        resetUpdatedate();
        resetUpdateman();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public TSSDTaskPolicy copyTo(TSSDTaskPolicy targetEntity)
	{
		BeanCopier copier=BeanCopier.create(TSSDTaskPolicy.class, TSSDTaskPolicy.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetTssdtaskpolicyid();
		return targetEntity;
	}
}